unit UDlgEdition;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, UVoiture, UVoitureUtilitaire;

type

  { TDlgEditVoiture }

  TDlgEditVoiture = class(TForm)
    Button1: TButton;
    Button2: TButton;
    chkUtilitaire: TCheckBox;
    edAge: TEdit;
    edCubage: TEdit;
    edCv: TEdit;
    edMarque: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure chkUtilitaireChange(Sender: TObject);
  private
  public
    procedure raz();
    procedure setVoiture(v: TVoiture);
    function getVoiture(): TVoiture;
  end;

var
  DlgEditVoiture: TDlgEditVoiture;

implementation

{$R *.lfm}

{ TDlgEditVoiture }

procedure TDlgEditVoiture.chkUtilitaireChange(Sender: TObject);
begin
  if (self.chkUtilitaire.Checked = True)
   then self.edCubage.Enabled:= True
   else self.edCubage.Enabled:= False;
end;

procedure TDlgEditVoiture.raz;
begin
  self.edMarque.Text:= '';
  self.edAge.Text:= '0';
  self.edCv.text:= '0';
  self.chkUtilitaire.Checked:= False;
  self.edCubage.Text:= '0';
end;

procedure TDlgEditVoiture.setVoiture(v: TVoiture);
begin
  //remplir les champs
  self.edMarque.Text:= v.marque;
  self.edAge.Text:= inttostr(v.age);
  self.edCv.Text:= inttostr(v.cv);
  //si voiture utilitaire
  if (V is TUtilitaire)
   then
    begin
      self.chkUtilitaire.checked:= True;
      self.edCubage.Text:= inttostr((v as TUtilitaire).cubage);
    end
  else
    begin
      self.edCubage.Enabled:= False;
    end;
end;

function TDlgEditVoiture.getVoiture: TVoiture;
var v: TVoiture;
    age, cv,cubage: integer;
    ok: boolean;
begin
  //vérifications
  ok:= self.edMarque.Text <> '';
  ok:= ok and TryStrToInt(self.edAge.Text,age);
  ok:= ok and TryStrToInt(self.edCv.Text,cv);
  if (self.chkUtilitaire.Checked = True)
   then ok:= ok and TryStrToInt(self.edCubage.Text,cubage);
  //si pas ok, on arrête
  if not(ok)
    //renvoyer sur le pointeur nil
    then result:= nil
    else
      begin
       //création de la bonne instance
       if (self.chkUtilitaire.Checked = True)
        then v:= TUtilitaire.create()
        else v:= TVoiture.create();
       //récupération des valeurs
       v.marque:= self.edMarque.Text;
       v.age:= age;
       v.cv:= cv;
       if (v is TUtilitaire)
        then (v as TUtilitaire).cubage:= cubage;
       //renvoyer le résultat
       result:= v;
      end;
end;

end.

