unit UFrmPrincipale;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Menus,
  ComCtrls, UVoiture;

type

  { TFrmPrincipale }

  TFrmPrincipale = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    lblTaxe: TLabel;
    lblCubage: TLabel;
    lblUtilitaire: TLabel;
    lblCv: TLabel;
    lblAge: TLabel;
    lblMarque: TLabel;
    ListBoxVoitures: TListBox;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    menuSommeTaxe: TMenuItem;
    menuNouveau: TMenuItem;
    menuOuvrir: TMenuItem;
    menuSauver: TMenuItem;
    menuQuitter: TMenuItem;
    MenuItem6: TMenuItem;
    menuAjouter: TMenuItem;
    menuEditer: TMenuItem;
    menuSupprimer: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Separator3: TMenuItem;
    Separator2: TMenuItem;
    Separator1: TMenuItem;
    procedure ListBoxVoituresDblClick(Sender: TObject);
    procedure ListBoxVoituresKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBoxVoituresSelectionChange(Sender: TObject; User: boolean);
    procedure menuAjouterClick(Sender: TObject);
    procedure menuEditerClick(Sender: TObject);
    procedure menuNouveauClick(Sender: TObject);
    procedure menuOuvrirClick(Sender: TObject);
    procedure menuQuitterClick(Sender: TObject);
    procedure menuSauverClick(Sender: TObject);
    procedure menuSommeTaxeClick(Sender: TObject);
    procedure menuSupprimerClick(Sender: TObject);
  private
    procedure RazLabels();
    procedure RazListBox();
    procedure AddToListBox(v: TVoiture);
  public

  end;

var
  FrmPrincipale: TFrmPrincipale;

implementation

{$R *.lfm}

uses
  UDlgEdition, UVoitureUtilitaire, LCLType, UFrmSommeTaxe, StrUtils, Types;

{ TFrmPrincipale }

procedure TFrmPrincipale.menuAjouterClick(Sender: TObject);
var v: TVoiture;
begin
  //remise à zéro des zones d'édition de la boîte de dialogue
  DlgEditVoiture.raz();
  //on fait quelque chose seulement si clic sur OK
  if (DlgEditVoiture.ShowModal() = mrOk)
   then
    begin
     //récupération des valeurs
     v:= DlgEditVoiture.getVoiture();
     //si valeurs valides
     if (v <> nil)
      then self.AddToListBox(v);//ajouter dans la liste si l'objet est ok
    end;
end;

procedure TFrmPrincipale.menuEditerClick(Sender: TObject);
var v,vNew: TVoiture;
    id: integer;
begin
  //numéro de l'élément sélectionné
  id:= self.ListBoxVoitures.ItemIndex;
  //récupérer la voiture sélectionnée
  if (id < 0)
   then MessageDlg('Sélection','Aucun item sélectionné',mtError,[mbOk],0)
   else
     begin
      //pointeur sur l'objet
      v:= self.ListBoxVoitures.Items.Objects[id] as TVoiture;
      //envoyer la voiture à traiter vers la boîte de dialogue
      DlgEditVoiture.setVoiture(v);
      //faire apparaître la boîte de dialogue et attendre
      if (DlgEditVoiture.ShowModal() = mrOk)
       then
        begin
         //récupérer la nouvelle
         vNew:= DlgEditVoiture.getVoiture();
         //si voiture valide
         if (vNew <> nil)
          then
           begin
            //supprimer la voiture courante
            v.free();
            //à la place...
            self.ListBoxVoitures.Items[id]:= vNew.ToString();
            self.ListBoxVoitures.Items.Objects[id]:= vNew;
           end
          //si pas valide, Message
          else MessageDlg('Saisie Voiture','Description non valide',mtError,[mbOk],0);
        end;
     end;
end;

procedure TFrmPrincipale.menuNouveauClick(Sender: TObject);
begin
 self.RazListBox();
end;

procedure TFrmPrincipale.menuOuvrirClick(Sender: TObject);
var F: TextFile;
    v: TVoiture;
    s: string;
    d: TStringDynArray;
begin
  if (self.OpenDialog.Execute() = True)
   then
    begin
     //vider la listbox
     self.RazListBox();
     //lire et aprser le fichier
     AssignFile(F,self.OpenDialog.FileName);
     Reset(F);
     while not(eof(F)) do
      begin
       //lire la ligne
       readln(F,s);
       //la décomposer avec le séparateur ';'
       d:= SplitString(s,';');
       //3è elément -> indique le type
       if (d[3] = 'utilitaire')
        then v:= TUtilitaire.create()
        else v:= TVoiture.create();
       //récupérer les champts
       v.marque:= d[0];
       v.age:= StrToInt(d[1]);
       v.cv:= StrToInt(d[2]);
       if (v is TUtilitaire)
        then (v as TUtilitaire).cubage:= StrToInt(d[4]);
       //ajouter dans la listbox
       self.AddToListBox(v);
      end;
     CloseFile(F);
    end;
end;

procedure TFrmPrincipale.menuQuitterClick(Sender: TObject);
begin
  self.close();
end;

procedure TFrmPrincipale.menuSauverClick(Sender: TObject);
var F: TextFile;
    i: integer;
begin
  if (self.SaveDialog.Execute() = True)
   then
    begin
     AssignFile(F,self.SaveDialog.FileName);
     Rewrite(F);
     for i:= 0 to pred(self.ListBoxVoitures.Items.Count) do
      writeln(F,(self.ListBoxVoitures.Items.Objects[i] as TVoiture).ToString());
     CloseFile(F);
    end;
end;

procedure TFrmPrincipale.menuSommeTaxeClick(Sender: TObject);
var somme: double;
    i: integer;
    v: TVoiture;
begin
  somme:= 0.0;
  //calculer la somme des taxes et la faire apparaître dans un formulaire d'affichage
  for i:= 0 to pred(self.ListBoxVoitures.Count) do
   begin
    v:= self.ListBoxVoitures.Items.Objects[i] as TVoiture;
    somme:= somme + v.taxe();
   end;
  //affichage dans le formulaire dédié
  frmSommeTaxe.edSumTax.Text:= FormatFloat('0.00',somme);
  frmSommeTaxe.Show();
end;

procedure TFrmPrincipale.menuSupprimerClick(Sender: TObject);
var id: integer;
    v: TObject;
begin
  //numéro de l'élément sélectionné
  id:= self.ListBoxVoitures.ItemIndex;
  //récupérer la voiture sélectionnée
  if (id < 0)
   then MessageDlg('Sélection','Aucun item sélectionné',mtError,[mbOk],0)
   else
     begin
      //libérer le véhicule sélectionné
      v:= self.ListBoxVoitures.Items.Objects[id];
      v.free();
      //supprimer la référence visible
      self.ListBoxVoitures.DeleteSelected();
      //raz des labels
      self.RazLabels();
     end;
end;

procedure TFrmPrincipale.RazLabels;
begin
  self.lblMarque.Caption:= '--';
  self.lblAge.Caption:= '--';
  self.lblCv.caption:= '--';
  self.lblUtilitaire.Caption:= '--';
  self.lblCubage.Caption:='--';
  self.lblTaxe.Caption:= '--';
end;

procedure TFrmPrincipale.RazListBox;
var i: integer;
begin
  //supprimer chaque objet (libérer l'espace mémoire)
  for i:= 0 to self.ListBoxVoitures.Items.Count-1 do
   self.ListBoxVoitures.Items.Objects[i].Free();
  //vider la partie visible
  self.ListBoxVoitures.Clear();
  //vider les labels
  self.RazLabels();
end;

procedure TFrmPrincipale.AddToListBox(v: TVoiture);
begin
  self.ListBoxVoitures.AddItem(v.ToString(),v);
  self.ListBoxVoitures.ItemIndex:= self.ListBoxVoitures.Count-1;
end;

procedure TFrmPrincipale.ListBoxVoituresSelectionChange(Sender: TObject;
  User: boolean);
var v: TVoiture;
begin
 if (self.ListBoxVoitures.ItemIndex >= 0)
  then
   begin
    //récupération de l'objet
    v:= self.ListBoxVoitures.Items.Objects[self.ListBoxVoitures.ItemIndex] as TVoiture;
    //inscription des informations
    self.lblMarque.Caption:= v.marque;
    self.lblAge.Caption:= IntToStr(v.age);
    self.lblCv.Caption:= IntToStr(v.cv);
    self.lblTaxe.Caption:= FormatFloat('0.00',v.taxe());
    //infos selon Utilitaire ou non...
    if (v is TUtilitaire)
     then
      begin
       self.lblUtilitaire.Caption:= 'oui';
       self.lblCubage.Caption:= IntToStr((v as TUtilitaire).cubage);
      end
     else
      begin
       self.lblUtilitaire.Caption:= 'non';
       self.lblCubage.Caption:='--';
      end;
   end
  else self.RazLabels();
end;

procedure TFrmPrincipale.ListBoxVoituresKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_DELETE)
   then self.menuSupprimerClick(Sender);
end;

procedure TFrmPrincipale.ListBoxVoituresDblClick(Sender: TObject);
begin
  if (self.ListBoxVoitures.ItemIndex >= 0)
   then self.menuEditerClick(Sender);
end;

end.

